=== debian/changelog ===
krita (1:6.0.0~beta2+dfsg-3) experimental; urgency=medium

  * Make use of the newer xsimd version that properly pulls/uses xtl:
    - bump the libxsimd-dev build dependency to 14.0.0-1
    - drop the xtl-dev build dependency, now fully an implicit dependency of
      xsimd
    - drop the xsimd-require-xtl.diff patch, as now xtl is already searched
      by xsimd
  * Backport the upstream MR
    https://invent.kde.org/graphics/krita/-/merge_requests/2657 to build on
    architectures not explicitly supported by xsimd; patch
    KoStreamedMath-fix-build-on-XSIMD_NO_SUPPORTED_ARCHITECTURE.patch.

 -- Pino Toscano <pino@debian.org>  Sun, 22 Feb 2026 11:13:14 +0100

krita (1:6.0.0~beta2+dfsg-2) experimental; urgency=medium

  * Since xsimd is now mandatory in krita, and it is available on all the
    architectures, then drop the architecture limitations for the libxsimd-dev,
    and xtl-dev build dependencies.

 -- Pino Toscano <pino@debian.org>  Sat, 21 Feb 2026 10:48:36 +0100

krita (1:6.0.0~beta2+dfsg-1) experimental; urgency=medium

  * New upstream development release:
    - supports Wayland (Closes: #955730)
  * Switch watch file to the unstable releases.
  * Switch Vcs-* fields to the 'experimental' packaging branch.
  * Update the build dependencies following the port to Qt 6:
    - remove libkf5completion-dev, libkf5config-dev, libkf5coreaddons-dev,
      libkf5crash-dev, libkf5guiaddons-dev, libkf5i18n-dev, libkf5itemviews-dev,
      libkf5kdcraw-dev, libkf5widgetsaddons-dev, libkf5windowsystem-dev,
      libpoppler-qt5-dev, libqt5opengl5-dev, libqt5svg5-dev,
      libqt5x11extras5-dev, libquazip1-qt5-dev, pyqt5-dev, python3-pyqt5,
      qtbase5-dev, qtbase5-private-dev, and qtdeclarative5-dev
    - temporarily remove libkseexpr-dev, as the Qt 6 version is not available
      yet
    - add libkdcrawqt6-dev, libkf6colorscheme-dev, libkf6completion-dev,
      libkf6config-dev, libkf6coreaddons-dev, libkf6crash-dev,
      libkf6guiaddons-dev, libkf6i18n-dev,  libkf6itemviews-dev,
      libkf6widgetsaddons-dev, libpoppler-qt6-dev, libquazip1-qt6-dev,
      pyqt6-dev, python3-pyqt6, python3-sipbuild, qt6-5compat-dev, qt6-base-dev,
      qt6-base-private-dev, qt6-declarative-dev, qt6-svg-dev, qt6-wayland-dev,
      and qt6-wayland-private-dev
  * Update the other build dependencies according to the upstream build system:
    - bump cmake to 3.19.0
    - bump extra-cmake-modules to 6.0
    - bump libopencolorio-dev to 2.0.0
  * Modernize building and update it to KF6:
    - add the dh-sequence-kf6 build dependency to use the kf6 addon
      automatically
    - drop the pkg-kde-tools build dependency, no more explicitly needed
    - drop all the manually specified addons and buildsystem for dh
  * Pass -DBUILD_WITH_QT6=ON to cmake to explicitly build using Qt 6.
  * Update the runtime relationships to Qt 6:
    - switch libqt5sql5-sqlite to libqt6sql6-sqlite
    - switch python3-pyqt5 to python3-pyqt6
    - switch qml-module-qtmultimedia to qml6-module-qtmultimedia
  * Update the patches:
    - upstream_Bump-SIP-ABI-version-to-12.8.patch: drop, fixed upstream
  * Stop adding -Wno-template-id-cdtor to the CXXFLAGS, as the warnings were
    fixed.
  * Append -Wno-deprecated -Wno-deprecated-declarations to the CXXFLAGS,
    as there are lots of deprecation warnings that make build logs bigger.
  * Update install files.
  * Add maintscript to remove the old /etc/xdg/kritarc conffile.

 -- Pino Toscano <pino@debian.org>  Sat, 21 Feb 2026 08:36:37 +0100
